## Version 2.5 Changelog

### [UNRELEASED]

#### Table of Contents
- [Screen Status Handler Enhancement](#screen-status-handler-enhancement)
- [Menu Options Customization](#menu-options-customization)
- [Logging Functionality](#logging-functionality)
- [Battery Check Function](#battery-check-function)
- [Added](#added)
- [Enhanced](#enhanced)
- [Changed](#changed)
- [Removed](#removed)
- [Fixed](#fixed)
- [Support for MIUI](#support-for-miui)
- [Bug Fixes and Optimizations](#bug-fixes-and-optimizations)
- [Testers](#testers)

#### Screen Status Handler Enhancement
- Added the ability to enable or disable the Screen Status Handler feature from the config file.
- When set to '1', the script will automatically enable the profile when the screen is off and disable it when the screen is on.
- When set to '0', the script is effectively paused, and no automatic actions will be taken.
- This provides greater control and flexibility for users to manage the script's behavior.
- Users can also configure a custom sleep timer for the Screen Handler function in the `.config` file.

#### Menu Options Customization
- Every menu option in the script can now be configured to apply changes either immediately or after a device reboot.
- Users can choose when to apply specific settings, giving them more control over their device's performance and power management.

#### Logging Functionality
- Added logging functionality to the script.
- A log file is now created at `/data/adb/modules/STRPxULTRAxBATTERY/SUB_Daemon.log`.
- Log actions and messages are recorded in the log file.
- Log size is checked and truncated if it exceeds 1MB (1048576 bytes).
- The log now indicates whether the script is running on Android OS or MIUI OS.
- Additionally, a `settings.log` file is created, logging changes made to `settings.conf` after a reboot based on user choices from the main menu.

#### Battery Check Function
- Added a battery check function to monitor battery status and take appropriate actions.

#### Support for MIUI
- Introduced support for MIUI-based devices.
- The script now detects whether the device is running MIUI and adjusts settings accordingly.

#### Added
- Merged the following scripts into one `SUB_Daemon`:
  - `cpu_gov_lock_screen_handler`: Controls CPU governors based on screen lock status.
  - `cpu_freq_on_lock_handler`: Manages CPU frequencies when the screen is locked or unlocked.
  - `data_wifi_on_lock_handler`: Controls mobile data and Wi-Fi when the screen is locked or unlocked.
  - `screen_off_profile_handler`: Handles screen status and profiles.
  - `auto_sub`:
    Handles SUB Battery Profile if the device's battery goes below 20%.

- **Sleep Timers for Customization**:
   - Users can now configure sleep timers for each SUB_Daemon function individually through the `.config` file, allowing them to control how often each function checks for conditions.

 - **Improved Battery Checker**:
   - Enhanced the battery checker code within the SUB_Daemon to check the current status of the battery profile (enabled or disabled) before taking any actions. This prevents constant enabling/disabling of the profile when the battery is under 20%.

- **Screen Handler as a Separate Function**:
   - The screen handler functionality has been separated into its own SUB_Daemon function, just like the other features. Users can choose to enable or disable this function using the configuration file.
   - Added a customizable sleep timer for the Screen Handler function to allow users to set how often it checks for screen status changes.

#### Enhanced
- Improved script efficiency by combining multiple functionalities into a single loop.

#### Changed
- Improved screen status detection by checking display state instead of brightness.
  - This change addresses an issue where the script now accurately determines the screen's on/off state.
- Special thanks to [@fashl1](https://t.me/fashl1) for reporting the issue.

#### Removed
- Removed individual scripts for CPU, WiFi and Mobile Data, CPU Governor, and Screen Status configurations.

#### Fixed
- Fixed issues related to CPU frequency handling and configuration.
- Fixed issues related to WiFi and Mobile Data control.
- Fixed issues related to CPU governor configuration.
- Fixed issues related to screen status handling.

#### Bug Fixes and Optimizations
- Improved script performance and stability.
- Resolved minor issues reported by users.

#### Testers
- Big thanks to...
- [@Lassmichdanke](https://t.me/Lassmichdanke)
- [@r15unygm4047](https://t.me/r15unygm4047)

Thank you for your continued support, and we hope you enjoy the enhanced features and flexibility in version 2.5!
------